#pragma once
#include <vector>
#include <fstream>

struct TreeNode {
	int data;
	std::vector<TreeNode*> children;
	TreeNode(int _data) : data(_data)
	{
	};
};

struct TreeNode2 {
	int data;
	TreeNode2* child;
	TreeNode2* sibling;
	TreeNode2(int _data) : data(_data)
	{
		child = sibling = nullptr;
	};
};

class Tree {
private:
	TreeNode* root;
	void clear(TreeNode* root);
	TreeNode* copy(TreeNode* root);
	void insert(TreeNode*& root, int* path, int level, int el);
	void howManySums(TreeNode*& root, int& count);
	bool isOnlyLarger(TreeNode* r);
public:

	Tree();
	Tree(const Tree& other);
	~Tree();
	void insert(int* path, int level, int el);
	// 1:
	//             ?
	int howManySums();
	// 2:
	//        -     .
	bool isOnlyLarger();
};

class Tree2
{
private:
	TreeNode2* root;
	void clear(TreeNode2* root);
	TreeNode2* copy(TreeNode2* root);
public:
	Tree2();
	Tree2(const Tree2& other);
	~Tree2();
};